﻿using UnityEngine;
using System.Collections;

public class OrbitalCamera : MonoBehaviour {

    float orbitalYaw = 0;
    float orbitalPitch = 0;
    float orbitalDistance=12;
    float attitudeIncrement = 20;
    float orbitalDistanceIncrement = 5;
    Quaternion q1, q2;
    Camera camera1;
    Vector3 p;
	
    void Start()
    {
        camera1 = GetComponent<Camera>();
    }

	// Update is called once per frame
	void Update () {
        //float elapsed = Time.deltaTime; //this should give a smooth twitch free rotation, but it doesn't always
        float elapsed = 1f / 60f; //this works better sometimes, could be a problem with deltaTime?
        if (Input.GetKey("d"))
        {
            orbitalYaw += attitudeIncrement * elapsed;
        }
        if (Input.GetKey("a"))
        {
            orbitalYaw -= attitudeIncrement * elapsed;
        }
        if (Input.GetKey("w"))
        {
            orbitalPitch -= attitudeIncrement * elapsed;
        }
        if (Input.GetKey("s"))
        {
            orbitalPitch += attitudeIncrement * elapsed;
        }
        if (Input.GetKey("k"))
        {
            orbitalDistance += orbitalDistanceIncrement * elapsed;
        }
        if (Input.GetKey("i"))
        {
            orbitalDistance -= orbitalDistanceIncrement * elapsed;
            if (orbitalDistance < 0.1)
            {
                orbitalDistance = 0.1f;
            }
        }
        q1 = Quaternion.AngleAxis(orbitalPitch, new Vector3(1, 0, 0));
        q2 = Quaternion.AngleAxis(orbitalYaw, new Vector3(0, 1, 0));
        camera1.transform.LookAt(new Vector3());
        p = q1 * new Vector3(0, 0, -orbitalDistance);
        p = q2 * p;
        camera1.transform.position = p;
    }
}
